###########################################################################
#
#   Copyright (c) 2000,2001 Morten W. Petersen <morten@esol.no>
#	Copyright (c) 2000,2001 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

# $Author: morten $
# $Revision: 1.5 $


__doc__ = 'Documentation string.'
__version__ = '0.1.0'

from Globals import HTMLFile
from Globals import Persistent
from Globals import default__class_init__
import Products
import Acquisition
import AccessControl.Role
import OFS.Folder
import calendar_month
import base_item
import time
import calendar
import utils

manage_add_calendar_year_form = HTMLFile('calendar_year_add', globals())


def manage_add_calendar_year(self, id, title, REQUEST=None, RESPONSE=None):
    "Add an instance of the calendar_year class"

    self._setObject(id, calendar_year(id, title))

    if RESPONSE is not None:

        RESPONSE.redirect(self.absolute_url())


class calendar_year(
	#Products.ZCatalog.CatalogAwareness.CatalogAware,	
	OFS.Folder.Folder,
	Persistent,
	Acquisition.Implicit,
	AccessControl.Role.RoleManager,
	base_item.base_item
	):
	"""Class used for time matrix."""

	meta_type = 'CalendarYear'
	icon = 'misc_/CalendarFolder/Folder_icon.gif'

	use_local_navigation = 0

	_properties = (
		{'id':'title', 'type':'string'},
		)

	"""
	meta_types = (
		{'name':'CalendarMonth', 'action':'manage_add_calendar_month_form'},
		)
	"""

	manage_add_calendar_month_form = calendar_month.manage_add_calendar_month_form
	manage_add_calendar_month = calendar_month.manage_add_calendar_month

	__ac_permissions__ = (
		('View management screens',
		 ('manage_tabs', 'manage_main')),
		('Change Permissions',
		 ('manage_access',)),
		('Add CalendarMonth',
		 ('manage_add_calendar_month', 'manage_add_calendar_month_form')),
		('View CalendarYears',
		 ('',)),
		)

	index_html = HTMLFile('calendar_year_index', globals())


	def get_context_year(self):

		return self


	def get_context_year_id(self):

		return self.id


	def get_year(self):
		"""Returns self."""

		return self


	def get_months(self):
		"""Returns a list of calendar months."""

		return self.objectValues('CalendarMonth')


	def get_next_year(self):
		"""Returns the next year, and creates it if it doesn't exist."""

		next_year = str(int(self.id) + 1)

		try: 

			self.getParentNode().aq_base[next_year]
			next_year = self.getParentNode()[next_year]

		except AttributeError:

			self.getParentNode().manage_add_calendar_year(next_year,
					next_year)

			next_year = self.getParentNode()[next_year]

		return next_year


	def get_previous_year(self):
		"""Returns the next year, and creates it if it doesn't exist."""

		previous_year = str(int(self.id) - 1)

		try: 

			self.getParentNode().aq_base[previous_year]
			previous_year = self.getParentNode()[previous_year]

		except AttributeError:

			self.getParentNode().manage_add_calendar_year(previous_year,
					previous_year)

			previous_year = self.getParentNode()[previous_year]

		return previous_year


	def simple_navigation_html(self):
		"""Returns a simple month navigation list."""

		calendar_month_list = []
		calendar_months = self.get_months()

		for month in calendar_months:

			calendar_month_list.append(
				"""<a href="%s/navigate">%s</a>""" % \
					(month.relative_url(),
					month.render_name()))

		return calendar_month_list


	def __init__(self, id, title=''):
		"Initialize the class instance"

		self.id = id
		self.title = title

		for month in range(1,13):

			self.manage_add_calendar_month(utils.pad_integer(month),
							title=calendar.month_name[month])

			for week in calendar.monthcalendar(int(self.id), month):

				for day in range(len(week)):

					if week[day]:

						self[utils.pad_integer(month)].manage_add_calendar_day(
							utils.pad_integer(week[day]),
							title=calendar.day_name[day])


default__class_init__(calendar_year)