###########################################################################
#
#   Copyright (c) 2000,2001 Morten W. Petersen <morten@esol.no>
#	Copyright (c) 2000 Erik Enge <erik@esol.no>
#	Copyright (c) 2000,2001 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

# $Author: morten $
# $Revision: 1.9 $


__doc__ = 'Documentation string.'
__version__ = '0.1.0'

from Globals import HTMLFile
from Globals import Persistent
from Globals import default__class_init__
import Acquisition
import AccessControl.Role
import OFS.Folder
import note
import product_base_item
import base_item
import string

manage_add_notes_form = HTMLFile('notes_add', globals())


def manage_add_notes(self, id, title, description,
			install_default_html='',
			install_default_theme='',
			install_default_id_generator='',
			REQUEST=None, RESPONSE=None):
	"""Add an instance of the Notes class."""

	self._setObject(id, notes(id, title, description,
				install_default_html=install_default_html,
				install_default_theme=install_default_theme,
				install_default_id_generator=install_default_id_generator))

	if RESPONSE is not None:

		RESPONSE.redirect(self.absolute_url())

	else:

		return self[id]


class notes(
	OFS.Folder.Folder,
	Persistent,
	Acquisition.Implicit,
	AccessControl.Role.RoleManager,
	product_base_item.product_base_item,
	base_item.base_item
	):
	"""Simple product for storing notes."""

	use_local_navigation = 0

	product_name = 'Notes'

	meta_type = 'Notes'
	icon = 'misc_/Notes/Folder_icon.gif'
	help_name = 'notes.stx'

	_properties = (
		{'id':'title', 'type':'string'},
		{'id':'description', 'type':'text'},
		)

	meta_types = (
		{'name':'Note', 'action':'manage_add_note_form'},
		)

	manage_add_note_form = note.manage_add_note_form
	manage_add_note = note.manage_add_note


	__ac_permissions__ = (
		('View management screens',
		 ('manage_tabs', 'manage_main')),
		('Change Permissions',
		 ('manage_access',)),
		('Add NoteSort',
		 ('manage_add_note_sort', 'manage_add_note_sort_form')),
		('View Notes',
		 ('',)),
		)

	index_html = HTMLFile('notes_index', globals())
	display = HTMLFile('notes_display', globals())
	note_add_without_context = HTMLFile('note_add_without_context', globals())


	def get_notes(self):
		"""Returns a list of notes."""

		return self.objectValues('Note')


	def __init__(self, id, title='', description='',
			install_default_html=None,
			install_default_theme=None,
			install_default_id_generator=None):
		"""Initialize the class instance."""

		self.id = id
		self.title = title
		self.description = description

		product_base_item.utils.default_installation(
			self,
			install_default_html=install_default_html,
			install_default_theme=install_default_theme,
			install_default_id_generator=install_default_id_generator
			)


default__class_init__(notes)

